//+------------------------------------------------------------------+
//|                      lukas1 arrows & curves.mq4       v.14       |
//|       :                                                 | 
//|       1.   () ,      |
//|            Kmin, Kmax, RISK                             |
//|       2.                  |
//|            ,    .    |
//|       3.   .                             |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, lukas1"
#property link      "http://www.alpari-idc.ru/"
//----
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Green
#property indicator_color5 Green
#property indicator_style5 STYLE_DOT
//---- input parameters
extern string TimeFrame       = "Current time frame";
extern int SSP       = 6;     //   
extern int CountBars = 2250;  //  
extern int SkyCh     = 13;    //    
//    0-50. 0 -  .  50 - 
double high, low, smin, smax;
double val1[];      //   
double val2[];      //   
double Sky_BufferH[];
double Sky_BufferL[];
double mid[];
bool   uptrend, old;

string indicatorFileName;
int    timeFrame;
bool   returnBars;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);        //   
   SetIndexBuffer(0, val1);      //    
   SetIndexDrawBegin(0, 2*SSP);
   //
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);        //   
   SetIndexBuffer(1, val2);      //    
   SetIndexDrawBegin(1, 2*SSP);
   //
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, Sky_BufferH);
   SetIndexLabel(2, "High");
   SetIndexDrawBegin(2, 2*SSP);
   //
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, Sky_BufferL);
   SetIndexBuffer(4, mid);
   SetIndexLabel(3, "Low");
   SetIndexDrawBegin(3, 2*SSP);
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Calculation of SilverTrend lines                                 | 
//+------------------------------------------------------------------+
int start()
{   
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(MathMax(Bars-counted_bars,CountBars),Bars-1);
         if (returnBars) { val1[0] = limit+1; return(0); }
         if (timeFrame!=Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for (i=limit;i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);
               int x = iBarShift(NULL,timeFrame,Time[i+1]);
               Sky_BufferH[i] = iCustom(NULL,timeFrame,indicatorFileName,"",SSP,CountBars,SkyCh,2,y);
               Sky_BufferL[i] = iCustom(NULL,timeFrame,indicatorFileName,"",SSP,CountBars,SkyCh,3,y);
               mid[i]         = iCustom(NULL,timeFrame,indicatorFileName,"",SSP,CountBars,SkyCh,4,y);
	            val1[i] = EMPTY_VALUE;  
               val2[i] = EMPTY_VALUE;
               if (x!=y)
               {
                  val1[i] = iCustom(NULL,timeFrame,indicatorFileName,"",SSP,CountBars,SkyCh,0,y);
                  val2[i] = iCustom(NULL,timeFrame,indicatorFileName,"",SSP,CountBars,SkyCh,1,y);
               }
            }
            return(0);
         }
//---- initial zero
   uptrend       =false;
   old           =false;
   GlobalVariableSet("goSELL", 0); //     goSELL=0
   GlobalVariableSet("goBUY", 0);  //     goBUY =0
//----
   for(i = limit; i >= 0; i--) //   shift  1  ;
     { 
       high = High[iHighest(Symbol(),0,MODE_HIGH,SSP,i)]; 
       low = Low[iLowest(Symbol(),0,MODE_LOW,SSP,i)]; 
       smax = high - (high - low)*SkyCh / 100; // smax  high   .SkyCh
       smin = low + (high - low)*SkyCh / 100;  // smin  low   .SkyCh
       val1[i] = EMPTY_VALUE;  
       val2[i] = EMPTY_VALUE;
       if(Close[i] < smin && i!=0 )	//    (i!=0)
       {
       uptrend = false;
       }
	    if(Close[i] > smax && i!=0 )	//    (i!=0)	
	    {
	    uptrend = true;       
       }       
       if(uptrend != old && uptrend == false)
         {
           val2[i] = high; //      val1
           if(i == 0)                GlobalVariableSet("goBUY",1);
         }
       if(uptrend != old && uptrend == true ) 
         {
           val1[i] = low; //      val2
           if(i == 0)                GlobalVariableSet("goSELL",1);
         }
       old=uptrend;
       Sky_BufferH[i]=high - (high - low)*SkyCh / 100;
       Sky_BufferL[i]=low +  (high - low)*SkyCh / 100;
       mid[i] = (Sky_BufferH[i]+Sky_BufferL[i])/2.0;
     }
   return(0);
  }
//+------------------------------------------------------------------+

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}
